##############################################################################
#
# Copyright (c) 2003 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

"""
  The XmlFix product disables the current Zope (2.6.3, 2.7.0) behavior of
  treating all HTTP POST requests with text/xml content bodies as XML-RPC
  requests. This makes it possible to write objects or scripts to handle
  SOAP requests or other kinds of requests that are sent via POST as xml.

  ** Note that installing this product will *completely* disable xml-rpc! **

  To enable, unpack the XmlFix product into your /Products directory and 
  restart Zope. This product is compatible with Zope 2.6.x and Zope 2.7.x.
  
"""

from ZPublisher.HTTPRequest import HTTPRequest
from StringIO import StringIO


def processInputs(self, *args, **kw):
    environ = self.environ
    method = environ.get('REQUEST_METHOD')
    c_type = environ.get('CONTENT_TYPE')

    if ((method == 'POST') and (c_type == 'text/xml')):
        # bwwaaahahahahahahaha.....
        self.environ['CONTENT_TYPE'] = 'text/xml-pass'
        r = self._realProcessInputs(*args, **kw)
        self.environ['CONTENT_TYPE'] = 'text/xml'
        return r

    return self._realProcessInputs(*args, **kw)


def initialize(context):
    HTTPRequest._realProcessInputs = HTTPRequest.processInputs
    HTTPRequest.processInputs = processInputs
